<template>
  <div class="upload-file">
    <el-upload
      multiple
      :action="uploadFileUrl"
      :before-upload="handleBeforeUpload"
      :data="data"
      :limit="limit"
      :file-list="fileList"
      :on-error="handleUploadError"
      :on-exceed="handleExceed"
      :on-success="handleUploadSuccess"
      :headers="headers"
      class="upload-file-uploader"
      ref="fileUpload"
      list-type="picture-card"
      v-if="!disabled"
    >
      <!-- 上传按钮 -->
      <el-button size="mini" type="primary">选取文件</el-button>
      <div slot="file" slot-scope="{ file }">
        <img class="el-upload-list__item-thumbnail" :src="file.url" alt />
        <span class="el-upload-list__item-actions">
          <span class="el-upload-list__item-preview" @click="handlePictureCardPreview(file)">
            <i class="el-icon-zoom-in"></i>
          </span>
          <span v-if="!disabled" class="el-upload-list__item-delete" @click="handleDownload(file)">
            <i class="el-icon-download"></i>
          </span>
          <span v-if="!disabled" class="el-upload-list__item-delete" @click="handleRemove(file)">
            <i class="el-icon-delete"></i>
          </span>
        </span>
      </div>
      <!-- 上传提示 -->
      <div class="el-upload__tip" slot="tip" v-if="showTip">
        请上传
        <template v-if="fileSize">
          大小不超过
          <b style="color: #f56c6c">{{ fileSize }}MB</b>
        </template>
        <template v-if="fileType">
          格式为
          <b style="color: #f56c6c">{{ fileType.join('/') }}</b>
        </template>
        的文件
      </div>
    </el-upload>
    <el-dialog :visible.sync="dialogVisible" :append-to-body="true">
      <img :src="dialogImageUrl" alt />
    </el-dialog>
  </div>
</template>

<script>
import { getToken } from '@/utils/auth'
import Sortable from 'sortablejs'

export default {
  name: 'FileUpload',
  props: {
    // 值
    value: [String, Object, Array],
    // 上传接口地址
    action: {
      type: String,
      default: '/common/upload',
    },
    // 上传携带的参数
    data: {
      type: Object,
    },
    // 数量限制
    limit: {
      type: Number,
      default: 4,
    },
    // 大小限制(MB)
    fileSize: {
      type: Number,
      default: 5,
    },
    // 文件类型, 例如['png', 'jpg', 'jpeg']
    fileType: {
      type: Array,
      default: () => ['doc', 'docx', 'xls', 'xlsx', 'ppt', 'pptx', 'txt', 'pdf'],
    },
    // 是否显示提示
    isShowTip: {
      type: Boolean,
      default: true,
    },
    // 禁用组件（仅查看文件）
    disabled: {
      type: Boolean,
      default: false,
    },
    // 拖动排序
    drag: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      number: 0,
      dialogVisible: false,
      uploadList: [],
      baseUrl: process.env.VUE_APP_BASE_API,
      uploadFileUrl: process.env.VUE_APP_BASE_API + this.action, // 上传文件服务器地址
      headers: {
        Authorization: 'Bearer ' + getToken(),
      },
      dialogImageUrl: '',
      fileList: [],
      // 添加标志位
      isInternalChange: false,
    }
  },
  watch: {
    // 回显
    value: {
      handler(newVal, oldVal) {
        // 只有当变化不是由组件内部引起时，才处理
        if (!this.isInternalChange) {
          if (newVal) {
            this.fileList = newVal.split(',').map((url) => ({ url: this.baseUrl + url }))
          } else {
            this.fileList = []
          }
        }
        // 重置标志位
        this.isInternalChange = false
      },
      deep: true,
      immediate: true,
    },
  },
  mounted() {
    if (this.drag && !this.disabled) {
      this.$nextTick(() => {
        const element = this.$refs.uploadFileList?.$el || this.$refs.uploadFileList
        element &&
          Sortable.create(element, {
            ghostClass: 'file-upload-darg',
            onEnd: (evt) => {
              const movedItem = this.fileList.splice(evt.oldIndex, 1)[0]
              this.fileList.splice(evt.newIndex, 0, movedItem)
              this.$emit('input', this.listToString(this.fileList))
            },
          })
      })
    }
  },
  computed: {
    // 是否显示提示
    showTip() {
      return this.isShowTip && (this.fileType || this.fileSize)
    },
  },
  methods: {
    // 上传前校检格式和大小
    handleBeforeUpload(file) {
      // 校检文件类型
      if (this.fileType) {
        const fileName = file.name.split('.')
        const fileExt = fileName[fileName.length - 1]
        const isTypeOk = this.fileType.indexOf(fileExt) >= 0
        if (!isTypeOk) {
          this.$modal.msgError(`文件格式不正确，请上传${this.fileType.join('/')}格式文件!`)
          return false
        }
      }
      // 校检文件名是否包含特殊字符
      if (file.name.includes(',')) {
        this.$modal.msgError('文件名不正确，不能包含英文逗号!')
        return false
      }
      // 校检文件大小
      if (this.fileSize) {
        const isLt = file.size / 1024 / 1024 < this.fileSize
        if (!isLt) {
          this.$modal.msgError(`上传文件大小不能超过 ${this.fileSize} MB!`)
          return false
        }
      }
      this.$modal.loading('正在上传文件，请稍候...')
      this.number++
      return true
    },
    // 文件个数超出
    handleExceed() {
      this.$modal.msgError(`上传文件数量不能超过 ${this.limit} 个!`)
    },
    // 上传失败
    handleUploadError(err) {
      this.$modal.msgError('上传文件失败，请重试')
      this.$modal.closeLoading()
    },
    // 上传成功回调
    handleUploadSuccess(res, file) {
      if (res.code === 200) {
        this.uploadList.push({ name: res.fileName, url: res.fileName })
        this.uploadedSuccessfully()
      } else {
        this.number--
        this.$modal.closeLoading()
        this.$modal.msgError(res.msg)
        this.$refs.fileUpload.handleRemove(file)
        this.uploadedSuccessfully()
      }
    },
    handleRemove(file) {
      const updatedFile = this.$refs.fileUpload.uploadFiles
      updatedFile.forEach((item, index) => {
        if (item.url === file.url) {
          // 从组件上传列表中移除文件
          updatedFile.splice(index, 1)
          // 从自己的上传列表中移除文件
          this.uploadList.splice(index, 1)
          // 在触发 input 事件前设置标志位
          this.isInternalChange = true
          this.$emit('handleRemove', this.listToString(this.uploadList))
        }
      })
    },
    handlePictureCardPreview(file) {
      this.dialogImageUrl = this.baseUrl + file.url
      this.dialogVisible = true
    },
    handleDownload(file) {
      console.log(file)
    },
    // 上传结束处理
    uploadedSuccessfully() {
      // 在触发 input 事件前设置标志位
      this.isInternalChange = true
      this.$emit('input', this.listToString(this.uploadList))
      this.$modal.closeLoading()
    },
    // 对象转成指定字符串分隔
    listToString(list, separator) {
      let strs = ''
      separator = separator || ','
      for (let i in list) {
        strs += list[i].url + separator
      }
      return strs != '' ? strs.substr(0, strs.length - 1) : ''
    },
  },
}
</script>

<style scoped lang="scss">
.file-upload-darg {
  opacity: 0.5;
  background: #c8ebfb;
}
.upload-file-uploader {
  margin-bottom: 5px;
}
.upload-file-list .el-upload-list__item {
  border: 1px solid #e4e7ed;
  line-height: 2;
  margin-bottom: 10px;
  position: relative;
}
.upload-file-list .ele-upload-list__item-content {
  display: flex;
  justify-content: space-between;
  align-items: center;
  color: inherit;
}
.ele-upload-list__item-content-action .el-link {
  margin-right: 10px;
}
</style>
